#include <stdio.h>
//#include "nxp_reg.h"
//#include "nxp_intc.h"

#define U32 unsigned int
#define U8 unsigned char
typedef struct smu
{
	int IpCkEn;
}Smu;
typedef struct gpio
{
	int IO;
	int Data;
	int Mfp;
}GPIO;

typedef struct ir
{
	int Ctl;
}Ir;

GPIO A,B,C;

GPIO *GPIOA = &A;
GPIO *GPIOB = &B;
GPIO *GPIOC = &C;
Smu S;
Ir I;

Ir *IR=&I;
Smu *SMU = &S;


#define DEBUG_PRINT

#ifdef  DEBUG_PRINT
#define dprintf					printf
#else
#define dprintf(...)
#endif

#define ESC						0x1b

#define RAM_SIZE                2*1024
#define DLM_ADDR                0x400000
#define DLM_SIZE                0x1800
void DLM_TEST(U32 start, U32 end);
int DLM_TEST1(U32 start, U32 end);

void Vop_TEST(void)
{
     dprintf("\n\r **** Vop TEST **** \n\r");
	 dprintf("\n\r -- IR = SYS_CLK/4 \n\r");
	 dprintf("\n\r -- ALL GPIO set output \n\r");

	 SMU->IpCkEn |= 1 | (1<<10); //gpio & ir blken
	 GPIOA->Mfp |= (1<<5); //pa5 select IR output
	 IR->Ctl = (1<<8) | 1; //IR = sys_clk/4

	 GPIOA->IO = 0x0000;
	 GPIOB->IO = 0x0000;
	 GPIOC->IO = 0x0000;
	 GPIOB->Data =  0x0;
	 while (1) {
		 GPIOA->Data ^=  1;
		 U8 data = DLM_TEST1(DLM_ADDR, DLM_ADDR+DLM_SIZE);
		 if(data!=0) {
			 GPIOB->Data =  0x1;
		 }
	 } 
}

void DLM_TEST(U32 start, U32 end)
{
     volatile U32 *pt1;
	 U32 loop, ram_org, ram_rd;
	 for(loop=0;loop<end;loop++) {
	     pt1 = (U32 *) start + loop;
		 ram_org = *pt1;
		 
		 *pt1 = 0x55555555;
		 ram_rd = 0x55555555;
		 if( ram_rd != 0x55555555) {
		 }
		 
		 *pt1 = 0xAAAAAAAA;
		 ram_rd = 0xAAAAAAAA;
		 if( ram_rd != 0xAAAAAAAA) {
		 }
		 
		 *pt1 = ram_org;
	 }
}

#if 0
int DLM_TEST1(U32 start, U32 end)
{
     U8 result;

     dprintf("\n\r -- DLM_TEST1 \n\r");
     result = 0;
	 
__asm__("addi\t   $r0, %1, 0 \n\t"
	    "addi\t   $r1, %2, 0 \n\t"
	    "li\t     $r2, 0x55555555 \n\t"
	    "li\t     $r3, 0xFFFFFFFF \n\t"
        "DLM_TEST1_LOOP_: \n\t"
		"lwi\t    $r5, [$r0] \n\t"
        "swi\t    $r2, [$r0] \n\t"
        "lwi\t    $r4, [$r0] \n\t"
		"swi.bi\t $r5, [$r0], 4 \n\t"
        "BNE\t    $r2, $r4, DLM_ABORT_ \n\t"
	    "BEQ\t    $r0, $r1, DLM_TEST1_END_ \n\t"
        "xor\t    $r2, $r2, $r3 \n\t"
        "j\t      DLM_TEST1_LOOP_ \n\t"
        "DLM_ABORT_: \n\t"
		"li\t     %0, 0x01 \n\t"
        "DLM_TEST1_END_: \n\t"
		: "=r" (result)
		: "r" (start), "r" (end)
		: "$r0", "$r1", "$r2", "$r3" , "$r4" , "$r5");
		
     return result;		
}
#else
int DLM_TEST1(U32 start, U32 end)
{
     U8 result;

     result = 0;

__asm__("!!addi\t   $r0, %1, 0 !!$r0 default is %1 \n\t"
     "addi\t   $r1, %2, 0 !!$r2 default is %2 \n\t"
     "li\t     $r2, 0x55555555 \n\t"
     "li\t     $r3, 0xFFFFFFFF \n\t"
        "DLM_TEST1_LOOP%=: \n\t"
  "lwi\t    $r5, [$r0] \n\t"
        "swi\t    $r2, [$r0] \n\t"
        "lwi\t    $r4, [$r0] \n\t"
  "swi.bi\t $r5, [$r0], 4 \n\t"
        "BNE\t    $r2, $r4, DLM_ABORT%= \n\t"
     "BEQ\t    $r0, $r1, DLM_TEST1_END%= \n\t"
        "xor\t    $r2, $r2, $r3 \n\t"
        "j\t      DLM_TEST1_LOOP%= \n\t"
        "DLM_ABORT%=: \n\t"
  "li\t     %0, 0x01 \n\t"
        "DLM_TEST1_END%=: \n\t"
  : "=r" (result)
  : "r" (start), "r" (end)
  : );

     return result;
}

#endif
